package com.gx.obe.business.enumeration;

import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.StringUtils;

public class ExpertEnum {
	
	/**
	 * 用于价格评审或推荐操作
	 */
	public static final String COMMON_EXPERT = "COMMON_EXPERT";
	/**
	 * 评标专家类型[0：成员；1：组长；02：备选专家]
	 */
	public static final String LEADER_NO = "0";
	public static final String LEADER_YES = "1";
	
	public static final String MONITOR = "00";
	public static final String WORKER = "01";
	
	/**
	 * 监督人员类型[00：监督人员 01：项目相关人员 02：本单位人员 03：上级单位人员]
	 */
	public static final String REALMONITOR = "00";
	public static final String BUYMONITOR = "01";
	
	public static final String getIsLeaderCN(String str) {
		String expertTypeCN = Messages.Expert;
		if (StringUtils.isNotEmpty(str)) {
			if (str.equals(LEADER_YES)) {
				expertTypeCN = "组长";
			}
		}
		return expertTypeCN;
	}
	
	/**
	 * 评标专家类型[01：专家；02：招标代表;11:商务组长:12技术组长]
	 */
	public static final String EXPERT = "01";
	public static final String BIDDING = "02";
	public static final String EXPERT_BUS_LEADER = "11";
	public static final String EXPERT_TEC_LEADER = "12";
	
	public static final String getExpertTypeCN(String expertType, String isLeader) {
		String expertTypeCN = Messages.Expert;
		if (EXPERT_BUS_LEADER.equals(expertType)) {
			expertTypeCN = Messages.BusinessLeader;
		}else if (EXPERT_TEC_LEADER.equals(expertType)) {
			expertTypeCN = Messages.TechnologyLeader;
		} else if (BIDDING.equals(expertType)) {
			expertTypeCN = Messages.BiddingLeader;
		} else {
			if(ExpertEnum.LEADER_YES.equals(isLeader)){
				expertTypeCN = Messages.Leader;
			}else {
				expertTypeCN = Messages.Expert;
			}
		}
		return expertTypeCN;
	}
	
	/**
	 * 专家评审类型[1：商务专家；2：技术专家；3：经济专家]
	 * 
	 */
	public static final int EXPERT_BUS = 1 << 1;
	public static final int EXPERT_TEC = 1 << 2;
	public static final int EXPERT_PRICE = 1 << 3;
	
	public static final String getEvalBidTypeCN(int evalBidType) {
		StringBuffer evaluationTypeCN = new StringBuffer();
		if ((evalBidType & EXPERT_BUS) != 0) {
			evaluationTypeCN.append(Messages.Business);
		}
		if ((evalBidType & EXPERT_TEC) != 0) {
			if (evaluationTypeCN.length() != 0) {
				evaluationTypeCN.append("，");
			}
			evaluationTypeCN.append(Messages.Technology);
		}
		if ((evalBidType & EXPERT_PRICE) != 0) {
			if (evaluationTypeCN.length() != 0) {
				evaluationTypeCN.append("，");
			}
			evaluationTypeCN.append(Messages.Economic);
		}
		return evaluationTypeCN.toString();
	}
	
	public static final String SIGN = "01";
	public static final String AVOID = "02";
	public static final String ALL = "03";
	
	public static final String getSignTypeCN(String str) {
		String expertTypeCN = Messages.SignInStatus_no;
		if (StringUtils.isNotEmpty(str)) {
			if (str.equals(SIGN)) {
				expertTypeCN = Messages.SignInStatus_yes;
			} else if (str.equals(AVOID)) {
				expertTypeCN = Messages.SignInStatus_avoid;
			}
		}
		return expertTypeCN;
	}
	
	/**
	 * 签署类型(01：已签署；02：未签署)
	 */
	public static final String PROMISE_YES = "01";
	public static final String PROMISE_NO = "02";
	
}
