package com.gx.obe.business.enumeration;

import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.StringUtils;

public class SupplierEnum {

	/**
	 * 开标状态01：开标成功,02：开标失败 ;01 :开标成功后重新报价
	 */
    public static final String OPENBID_SUCCESS  = "01";
    public static final String OPENBID_FIALE  = "02";
    public static final String OPENBID_SUCCESS_RE_EDIT  = "11";
    public static final String OPENBID_SUCCESS_DOWNLOADING  = "99";
    public static final String getOpenBidStatusCN(String str) {
    	String bidOpeningStatusCN = "未开标";
		if(StringUtils.isNotEmpty(str)){
			if(str.equals(OPENBID_SUCCESS)){
				bidOpeningStatusCN = "开标成功";
			}else if(str.equals(OPENBID_FIALE)){
				bidOpeningStatusCN = "开标失败";
			}
		}
		return bidOpeningStatusCN;
    }
    
    /**
     * 确认状态 01：确认；02：质疑；03：超时未确认
     */
    public static final String CONFIRM_YES = "01";
    public static final String CONFIRM_QUESTION  = "02";
    public static final String CONFIRM_TIME_OUT = "03";
    
    /**
     * 签到状态01：已签到,00：未签到
     */
    public static final String SIGN_YES  = "01";
    public static final String getSignStatusCN(String str) {
    	String signStatusCN = Messages.SignInStatus_no;
    	if(StringUtils.isNotEmpty(str)){
    		if(str.equals(SIGN_YES)){
    			signStatusCN = Messages.SignInStatus_yes;
    		}
    	}
    	return signStatusCN;
    }

    
    /**
	 * 废标状态00：未废标,01：已废标
	 */
    public static final String REVOKE_NO  = "00";
    public static final String REVOKE_YES  = "01";
    
    /**
	 * 签到类型【00：本地签到；01：远程签到】
	 */
    public static final String SIGN_LOCAL  = "00";
    public static final String SIGN_REMOTE  = "01";
    public static final String SIGN_BY_MANAGER  = "02";
    public static final String getSignTypeCN(String str){
    	String signTypeStr = Messages.SignInStatus_no;
    	if(StringUtils.isNotEmpty(str)){
    		if(str.equals(SIGN_REMOTE)){
    			signTypeStr = "远程签到";
    		}else if(str.equals(SIGN_LOCAL)){
    			signTypeStr = "现场签到";
    		}else if(str.equals(SIGN_REMOTE)){
    			signTypeStr = "项目经理辅助签到";
    			
    		}
    	}
    	return signTypeStr;
    }
    
    /**
     * 推荐【00：不推荐或（不入围）；01：推荐（入围）】
     */
    public static final String RECOMMONED_NO  = "00";
    public static final String RECOMMONED_YES  = "01";
    public static final String LIMIT_BID  = "02";
    public static final String getRecommonedCN(String str){
    	String recommonedStr = "未推荐";
    	if(StringUtils.isNotEmpty(str)){
    		if(str.equals(RECOMMONED_YES)){
    			recommonedStr = "推荐";
    		} else if(str.equals(LIMIT_BID)){
    			recommonedStr = "限中单位";
    		}
    	}
    	return recommonedStr;
    }
    
    /**
     * 首备选[01:首选;02:备选]
     */
    public static final String NO_RECOMEND = "00";
    public static final String CHOICE_FIRST = "01";
    public static final String CHOICE_ALTERNATIVE = "02";
    
    /**
     * 投递标书类型 01：在线投递成功；02：现场导入电子标书；03：纸质标书
     */
    public static final String ONLINE_ELECTRONIC = "01";
    public static final String IMPORT_ELECTRONIC = "02";
    public static final String PAPER = "03";
    public static final String getSupplierTenderType(String tenderType){
    	if(null == tenderType || "".equals(tenderType)){
    		return "";
    	}else if(tenderType.equals(ONLINE_ELECTRONIC)){
    		return "在线成功投递";
    	}else if(tenderType.equals(IMPORT_ELECTRONIC)){
    		return "现场导入电子标书";
    	}else if(tenderType.equals(PAPER)){
    		return "纸质标书";
    	}
    	return "";
    }
}
