package com.gx.obe.business.http;

import java.net.Authenticator;
import java.net.PasswordAuthentication;

import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.util.utils.StringUtil;

/**
 * @author huangz
 * 系统设置代理服务器
 *
 */
public class HttpProxyUtil {
	/**
	 * 系统初始化代理服务器
	 */
	public static void setProxy() {
		String useProxyStatus = PropertiesUtils.getProperty(ConfigConstants.USE_PROXY_STATUS, "");
		if(!StringUtil.empty(useProxyStatus) && useProxyStatus.equals(CommonEnum.YES)) {
			String proxyAddress = PropertiesUtils.getProperty(ConfigConstants.PROXY_ADDRESS, "");
			String proxyPort = PropertiesUtils.getProperty(ConfigConstants.PROXY_PORT, "");
			String proxyUserName = PropertiesUtils.getProperty(ConfigConstants.PROXY_USER_NAME, "");
			String proxyPassWord = PropertiesUtils.getProperty(ConfigConstants.PROXY_PASS_WORD, "");
			if(!StringUtil.empty(proxyAddress) && !StringUtil.empty(proxyPort)) {
				System.setProperty("http.proxyHost", proxyAddress);  
				System.setProperty("http.proxyPort", proxyPort);  
			}
			
			String proxyVerifyStatus = PropertiesUtils.getProperty(ConfigConstants.PROXY_VERIFY_STATUS, "");
			if(!StringUtil.empty(proxyVerifyStatus) && proxyVerifyStatus.equals(CommonEnum.YES)) {
				if(!StringUtil.empty(proxyUserName) && !StringUtil.empty(proxyPassWord)) {
					Authenticator.setDefault(new MyAuthenticator(proxyUserName, proxyPassWord));
				}
			}
		}
		
	}
}
class MyAuthenticator extends Authenticator {
    private String user = "";
    private String password = "";
  
    public MyAuthenticator(String user, String password) {
      this.user = user;
      this.password = password;
    }
  
    protected PasswordAuthentication getPasswordAuthentication() {
      return new PasswordAuthentication(user, password.toCharArray());
    }
  }