package com.gx.obe.business.http;

import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.StringUtils;

import net.sf.json.JSONArray;
import net.sf.json.JSONObject;

public class HttpResponse {

	private boolean status;
	private String content;
	private String msg;
	private JSONObject root;
	private JSONObject dataJsonObject;
	private JSONObject headerJsonObject;
	
	public boolean getStatus() {
		return status;
	}
	public void setStatus(boolean status) {
		this.status = status;
	}
	public String getContent() {
		return content;
	}
	public void setContent(String content) {
		this.content = content;
	}
	public String getMsg() {
		return null != msg ? msg : "";
	}
	public void setMsg(String msg) {
		this.msg = msg;
	}
	
	public void initHttpResponse() {
		if(StringUtils.isEmpty(content)) {
			this.msg = Messages.Tips_FailedToConnectServer;
			return ;
		}else {
			if(content.startsWith("<html>")) {
				this.msg = "接口请求异常！";
				return ;
			}
		}

		try {
			root = JSONObject.fromObject(content);
			if(null != root){
				headerJsonObject = (JSONObject)root.get("header");	
				if(null != headerJsonObject) {
					String retFlag = (String)headerJsonObject.get("ret");
					if(null == retFlag) {
						retFlag = (String)headerJsonObject.get("returnCode");
					}
					if("0".equals(retFlag)){
						this.status = true;
					}else {
						if(null != headerJsonObject && null != headerJsonObject.get("msg")){
							this.msg = headerJsonObject.get("msg").toString();
						}
					}
				}else {
					this.status = true;
				}
				dataJsonObject = (JSONObject)root.get("data");	
			}
		} catch (Exception e) {
			this.status = false;
		}
	
	}
	
	public JSONArray getDataJSONArray(String key) {
		if(null != dataJsonObject) {
			return (JSONArray)dataJsonObject.get(key);
		}
		return null;
	}
	public JSONObject getDataJSONObject(String key) {
		if(null != dataJsonObject) {
			return (JSONObject)dataJsonObject.get(key);
		}
		return null;
	}

	public String getDataParam(String key) {
		if (null == dataJsonObject) {
			return null;
		}
		Object object = dataJsonObject.get(key);
		if (object instanceof String) {
			return (String) object;
		}
		return null;
	}
	public JSONObject getJSONObject(String key) {
		if(null != root) {
			return (JSONObject)root.get(key);
		}
		return null;
	}
	public Object getParam(String key) {
		if(null != root) {
			return root.get(key);
		}
		return null;
	}
	public Object getHeaderParam(String key) {
		if(null != headerJsonObject) {
			return headerJsonObject.get(key);
		}
		return null;
	}
}
