package com.gx.obe.business.http;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;

import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSession;
import javax.net.ssl.TrustManager;

import org.apache.log4j.Logger;
import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;
import org.eclipse.swt.core.CallBack;

public class HttpURLConnectionUtils {
	
	public static final String ENCODING_REQUEST = "utf-8";
	public static final String ENCODING_RESPONSE = "utf-8";
	private static Logger LOG = Logger.getLogger(HttpURLConnectionUtils.class);	
	
	/** 
	 * @Description: 获得httpUrl流内容 
	 * @author guoyr
	 * @param   
	 * @return  
	 * @Exception   
	 */
	public static String getHttpUrlResult(String httpUrl, CallBack callBack){
		HttpURLConnection httpURLConnection;
		
        try {
        	
        	if(null == httpUrl || "".equals(httpUrl)){
        		if(null != callBack){
        			callBack.callBackError("请求的url地址为空！");
        		}
        		LOG.error("请求的url地址为空！");
        		return "";
        	}
        	if(null != callBack){
    			callBack.callBackString("  正在获取下载地址...");
    		}
            
            // 是否有参数
            boolean hasParams =  httpUrl.indexOf("?")>0;
            	
//            	String temp = httpUrl.substring(httpUrl.indexOf("prjCode=")+("prjCode=".length()));
//            	
//            	newUrl = httpUrl.replace(temp, URLEncoder.encode(temp, ENCODING_RESPONSE));
            	
            String newUrl = httpUrl;
            if(hasParams){
            	newUrl = httpUrl.substring(0, httpUrl.indexOf("?"));
            	LOG.error("转换后的Url:--------->" + newUrl);
            }
            SSLContext sslcontext=SSLContext.getInstance("SSL","SunJSSE");
    		sslcontext.init(null ,  new TrustManager[]{new MyX509TrustManager()}, new java.security.SecureRandom());
    		URL gatewayUrl = new URL(newUrl);
    		HostnameVerifier ignoreHostnameVerifier = new HostnameVerifier() {
    			public boolean verify(String s, SSLSession sslsession) {
    				System.out.println("WARNING: Hostname is not matched for cert.");
    				return true;
    			}
    		};
    		HttpsURLConnection.setDefaultSSLSocketFactory(sslcontext.getSocketFactory());
    		HttpsURLConnection.setDefaultHostnameVerifier(ignoreHostnameVerifier);
            
            httpURLConnection = (HttpURLConnection) gatewayUrl.openConnection();

            //设置连接属性
            httpURLConnection.setDoOutput(true);
            httpURLConnection.setDoInput(true);
            httpURLConnection.setRequestMethod("POST");
            httpURLConnection.setUseCaches(false);
          
            if(hasParams){
            	String params = httpUrl.substring(httpUrl.indexOf("?") + 1);
            	String[] paramsArray = params.split("&");
            	StringBuilder newParams = new StringBuilder();
            	for(String param : paramsArray){
            		if(param.length() > 0){
            			
            			if(newParams.length() >0){
            				newParams.append("&");
            			}
            			if(param.startsWith("prjCode") && param.indexOf("=") > 0){
            				String prjCode = param.split("=")[1];
            				prjCode = URLEncoder.encode(prjCode, ENCODING_RESPONSE);
            				newParams.append(param.split("=")[0]).append("=").append(prjCode);
            			}else if(param.startsWith("packCode") && param.indexOf("=") > 0){
            				String prjCode = param.split("=")[1];
            				prjCode = URLEncoder.encode(prjCode, ENCODING_RESPONSE);
            				newParams.append(param.split("=")[0]).append("=").append(prjCode);
            			}else {
            				newParams.append(param);
            			}
            		}
            	}
            	LOG.error("转换后的参数:--------->" + newParams.toString());
            	byte[] bypes = newParams.toString().getBytes();
            	httpURLConnection.getOutputStream().write(bypes);// 输入参数
            }

            //获得响应状态
            int responseCode = httpURLConnection.getResponseCode();

            StringBuffer responseBuffer = new StringBuffer("");
            if (HttpURLConnection.HTTP_OK == responseCode) {
                //当正确响应时处理数据
                String readLine;
                BufferedReader responseReader;
                //处理响应流，必须与服务器响应流输出的编码一致
                responseReader = new BufferedReader(new InputStreamReader(httpURLConnection.getInputStream(),  ENCODING_RESPONSE));
                while ((readLine = responseReader.readLine()) != null) {
                    responseBuffer.append(readLine);
                }
                responseReader.close();
                LOG.error("Http Response:" + responseBuffer);
            }
            return responseBuffer.toString();
        } catch (Exception e) {
        	LOG.error("请求url时出错，未能连接到服务器！",e);
        	if(null != callBack){
    			callBack.callBackError("请求url时出错，未能连接到服务器！");
    		}
    		return "";
        }
	}
	
	/** 
	 * @Description: 解析获取招标文件的下载地址
	 * @author guoyr
	 * @param   
	 * @return  
	 * @Exception   
	 */
	public static String resolveTenderDownXml(String xmlStr){
		/*
		
		StringBuilder xmlSb = new StringBuilder(); 
		
		xmlSb.append("<?xml version='1.0' encoding='utf-8' ?> ");
		xmlSb.append(" <getPrjPurchaseFile xmlns=''>");
		xmlSb.append(" <header>");
		xmlSb.append("  <operTag>Y</operTag> ");
		xmlSb.append("  <operDesc /> ");
		xmlSb.append("  </header>");
		xmlSb.append("  <body>");
		xmlSb.append("	<project>");
		xmlSb.append("  <projCode>GK-20110608-004</projCode> ");
		xmlSb.append("	<purchaseFile>");
		xmlSb.append("  <fileName>招标文件.zip</fileName> ");
		xmlSb.append("  <downUrl>http://192.168.7.90:8888/epses/DownloadFileHttpServlet?attachmentObjId=402887da306dac9a01306dcd2e61001d</downUrl> ");
		xmlSb.append("	</purchaseFile>");
		xmlSb.append("  </project>");
		xmlSb.append("  </body>");
		xmlSb.append("  </getPrjPurchaseFile>");
		xmlStr = xmlSb.toString();
		 * */
		String  downUrl = ""; 
		if(null != xmlStr && !"".equals(xmlStr)){
			try {
				Document document = DocumentHelper.parseText(xmlStr);
				Element root = document.getRootElement();
				Element project = root.element("body").element("project");
				String projectCode = project.elementTextTrim("projCode");
				String fileName = project.element("purchaseFile").elementTextTrim("fileName");
				downUrl = project.element("purchaseFile").elementTextTrim("downUrl");
				LOG.debug(projectCode +"  "+fileName +"  " + downUrl);
				LOG.debug(root.element("header").elementTextTrim("operTag"));
				LOG.debug(root.element("header").elementTextTrim("operDesc"));
				if(null == downUrl){
					downUrl = "";
				}
			} catch (Exception e) {
				downUrl = "";
			}
		}
		return downUrl;
	}
	
	/** 
	 * @Description: 解析获取投标文件的下载地址
	 * @author guoyr
	 * @param   
	 * @return  
	 * @Exception   
	 */
	public static String resolveSupplierDownXml(String xmlStr){
		/*
		
		StringBuilder xmlSb = new StringBuilder(); 
		
		xmlSb.append("<?xml version='1.0' encoding='utf-8' ?> ");
		xmlSb.append(" <getPrjPurchaseFile xmlns=''>");
		xmlSb.append(" <header>");
		xmlSb.append("  <operTag>Y</operTag> ");
		xmlSb.append("  <operDesc /> ");
		xmlSb.append("  </header>");
		xmlSb.append("  <body>");
		xmlSb.append("	<project>");
		xmlSb.append("  <projCode>GK-20110608-004</projCode> ");
		xmlSb.append("	<bidFile>");
		xmlSb.append("  <fileName>保障房建设.doc</fileName> ");
		xmlSb.append("  <downType>http</downType> ");//	downType为下载协议类型，ftp(ftp方式下载) http(http方式下载)
		xmlSb.append("  <downUrl>http://192.168.7.90:8888/epses/DownloadFileHttpServlet?attachmentObjId=402887da306dac9a01306dcd2e61001d</downUrl> ");
		xmlSb.append("	</bidFile>");
		xmlSb.append("  </project>");
		xmlSb.append("  </body>");
		xmlSb.append("  </getPrjPurchaseFile>");
		xmlStr = xmlSb.toString();
		 * */
		String  downUrl = ""; 
		if(null != xmlStr && !"".equals(xmlStr)){
			try {
				Document document = DocumentHelper.parseText(xmlStr);
				Element root = document.getRootElement();
				Element project = root.element("body").element("project");
				String fileName = project.element("bidFile").elementTextTrim("fileName");
				downUrl = project.element("bidFile").elementTextTrim("downUrl");
				LOG.debug(fileName +"  " + downUrl);
				LOG.debug(root.element("header").elementTextTrim("operTag"));
				LOG.debug(root.element("header").elementTextTrim("operDesc"));
				if(null == downUrl){
					downUrl = "";
				}
			} catch (Exception e) {
				downUrl = "";
			}
		}
		return downUrl;
	}
	
	public static void main(String[] args){
		String[] ar = "".split("&");
		System.out.println(ar[0].split("="));
//		HttpURLConnectionUtils httpUrlUtil = new HttpURLConnectionUtils();
//		System.out.println(httpUrlUtil.resolveTenderDownXml(""));
	}
}
