package com.gx.obe.business.vo;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

import com.gx.obe.util.utils.BigDecimalUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.web.entity.evaluation.EvaluationStep;

/**
 * @Description: 
 * @author guoyr
 */
/**
 * @preserve private
 */
public class ArithmeticErrorCheckResult {

	private String id;
	private String name;//评审项目
	private BigDecimal price;// 投标报价
	private BigDecimal countPrice;// 计算报价
	private BigDecimal difference;// 差额
	private BigDecimal differenceRate;
	private boolean reasonable;// 是否合理
	private String opinion ;// 检查结果
	private EvaluationStep evaluationStep;
	private ArithmeticErrorCheckResult parent;
	private String checkType;
	private String parentId;
	private List<ArithmeticErrorCheckResult> childList = new ArrayList<ArithmeticErrorCheckResult>();
	
	public ArithmeticErrorCheckResult(EvaluationStep evaluationStep){
		this.evaluationStep = evaluationStep;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public BigDecimal getPrice() {
		return price;
	}
	public void setPrice(BigDecimal price) {
		this.price = price;
	}
	public BigDecimal getCountPrice() {
		return countPrice;
	}
	public void setCountPrice(BigDecimal countPrice) {
		this.countPrice = countPrice;
	}
	public BigDecimal getDifferenceRate() {
		if(null != differenceRate){
			return differenceRate;
		}else {
//			differenceRate = BigDecimalUtils.mul(BigDecimalUtils.div(getDifference(), getPrice(), 4), BigDecimal.valueOf(100));
			differenceRate = BigDecimalUtils.mul(BigDecimalUtils.div(getDifference(), getPrice()), BigDecimal.valueOf(100));
			if(differenceRate.compareTo(BigDecimal.ZERO) == 0){
				differenceRate = BigDecimal.ZERO;
			}
		}
		return differenceRate;
	}
	public void setDifferenceRate(BigDecimal differenceRate) {
		this.differenceRate = differenceRate;
	}
	public BigDecimal getDifference() {
		if(null != difference){
			return difference;
		}else {
//			difference = BigDecimalUtil.difference(price, countPrice);
			difference = BigDecimalUtils.sub(getPrice(), getCountPrice());
//			if(difference.compareTo(BigDecimal.ZERO)== 0){
//				difference = BigDecimal.ZERO;
//			}
			if(null == difference){
				difference = BigDecimal.ZERO;
			}
		}
		return difference;
	}
	public void setDifference(BigDecimal difference) {
		this.difference = difference;
	}
	public boolean isReasonable() {
		String calculationError = evaluationStep.getEvaluationParamByKey(EvaluationStep.CALCULATION_ERROR);
		// 如果是根据差额率来计算
		if(ObjectUtils.equals(calculationError, EvaluationStep.CALCULATION_ERROR_RATE)){
			BigDecimal rate = evaluationStep.getEvaluationParamByKey(EvaluationStep.CALCULATION_ERROR_RATE, BigDecimal.class);
			if(null == rate || rate.compareTo(BigDecimal.ZERO) == 0){
				rate = BigDecimal.valueOf(5);
			}
			
			BigDecimal _differenceRate = getDifferenceRate();
			// 如果差额率小于0
			if(getDifferenceRate().compareTo(BigDecimal.ZERO) < 0){
				_differenceRate = BigDecimalUtils.sub(BigDecimal.ZERO, getDifferenceRate());
			}
			if(_differenceRate.compareTo(rate) > 0){
				reasonable = false;
			}else {
				reasonable = true;
			}
		}else {
			
			BigDecimal value = evaluationStep.getEvaluationParamByKey(EvaluationStep.CALCULATION_ERROR_VALUE, BigDecimal.class);
			if(null == value || value.compareTo(BigDecimal.ZERO) == 0){
				value = BigDecimal.valueOf(20);
			}
			BigDecimal _difference = getDifference();
			// 如果差额小于0
			if(getDifference().compareTo(BigDecimal.ZERO) < 0){
				_difference = BigDecimalUtils.sub(BigDecimal.ZERO, getDifference());
			}
			if(_difference.compareTo(value) > 0){
				reasonable = false;
			}else {
				reasonable = true;
			}
		}
		return reasonable;
	}
	public void setReasonable(boolean reasonable) {
		this.reasonable = reasonable;
	}
	public String getOpinion() {
		return opinion;
	}
	public void setOpinion(String opinion) {
		this.opinion = opinion;
	}
	public ArithmeticErrorCheckResult getParent() {
		return parent;
	}
	public void setParent(ArithmeticErrorCheckResult parent) {
		this.parent = parent;
	}
	public List<ArithmeticErrorCheckResult> getChildList() {
		return childList;
	}
	public void setChildList(List<ArithmeticErrorCheckResult> childList) {
		this.childList = childList;
	}
	public void addChild(ArithmeticErrorCheckResult child){
		childList.add(child);
	}
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	public String getParentId() {
		return parentId;
	}
	public void setParentId(String parentId) {
		this.parentId = parentId;
	}
	public String getCheckType() {
		return checkType;
	}
	public void setCheckType(String checkType) {
		this.checkType = checkType;
	}
	
}
