package com.gx.obe.business.vo;

import java.math.BigDecimal;

/** 
 * @Description: 
 * @author chenxw 
 */
/**
 * @preserve private
 */
public class BillFilter {

	/**
	 * 
	 */
	private static final long serialVersionUID = -6151931686314555033L;
	/**
	 * 列出全部项目
	 */
	public static final String ALL = "all";
	/**
	 * 列出低于评标控制线的项目
	 */
	public static final String UNDER_CONTROL_LINE = "underControlLine";
	/**
	 * 列出超过评标控制线200%的项目
	 */
	public static final String EXCEED_DOUBLE_CONTROL_LINE = "exceedDoubleControlLine";
	/**
	 * 按偏差百分比过滤项目
	 */
	public static final String AMONG_DEVIATION_PERCENTAGE = "amongDeviationPercentage";

	private String id;

	private BigDecimal minDeviationPercentage;
	private BigDecimal maxDeviationPercentage;
	private BigDecimal minWeight;
	private BigDecimal maxWeight;
	private String filterType = UNDER_CONTROL_LINE;
	private boolean isWeightAmong = false;

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public BigDecimal getMinDeviationPercentage() {
		return null != minDeviationPercentage ? minDeviationPercentage : new BigDecimal(-1);
	}

	public void setMinDeviationPercentage(BigDecimal minDeviationPercentage) {
		this.minDeviationPercentage = minDeviationPercentage;
	}

	public BigDecimal getMaxDeviationPercentage() {
		return null != maxDeviationPercentage ? maxDeviationPercentage : new BigDecimal(0);
	}

	public void setMaxDeviationPercentage(BigDecimal maxDeviationPercentage) {
		this.maxDeviationPercentage = maxDeviationPercentage;
	}

	public BigDecimal getMinWeight() {
		return null != minWeight ? minWeight : BigDecimal.ZERO;
	}

	public void setMinWeight(BigDecimal minWeight) {
		this.minWeight = minWeight;
	}

	public BigDecimal getMaxWeight() {
		return null != maxWeight ? maxWeight : new BigDecimal(1);
	}

	public void setMaxWeight(BigDecimal maxWeight) {
		this.maxWeight = maxWeight;
	}

	public String getFilterType() {
		return filterType;
	}

	public void setFilterType(String filterType) {
		this.filterType = filterType;
	}

	public boolean isWeightAmong() {
		return isWeightAmong;
	}

	public void setWeightAmong(boolean isWeightAmong) {
		this.isWeightAmong = isWeightAmong;
	}

}