package com.gx.obe.business.vo;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.HashMap;
import java.util.Map;

/** 
 * @Description: 汇率
 * @author chenxw 
 */
/**
 * @preserve private
 */
public class ExchangeRate implements Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private String id;
	private Map<String, BigDecimal> exchangeRateMap = new HashMap<String, BigDecimal>();
	
	public ExchangeRate(Map<String, BigDecimal> exchangeRateMap) {
		this.exchangeRateMap.putAll(exchangeRateMap);
	}
	
	public ExchangeRate() {}
	
	public String getId() {
		return id;
	}
	
	public void setId(String id) {
		this.id = id;
	}
	
	public int size() {
		return exchangeRateMap.size();
	}
	
	public void put(String currencyCode, BigDecimal exchangeRate) {
		exchangeRateMap.put(currencyCode, exchangeRate);
	}
	
	public void putAll(Map<String, BigDecimal> exchangeRateMap) {
		this.exchangeRateMap.putAll(exchangeRateMap);
	}
	
	public BigDecimal get(String currencyCode) {
		return exchangeRateMap.get(currencyCode);
	}
	
	public Map<String, BigDecimal> getExchangeRateMap() {
		return exchangeRateMap;
	}
	
}
