package com.gx.obe.business.vo;

import com.gx.obe.web.entity.evaluation.EvaluationFactor;
import com.gx.obe.web.entity.price.BidPrice;
import com.gx.obe.web.entity.price.BidPriceResult;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;

/**
 * @preserve private
 */
public class PriceEvaluationFactor {

	private TenderProjectRuleEntity tenderProjectRuleEntity;
	private BidPrice bidPrice;
	private BidPriceResult bidPriceResult;
	private EvaluationFactor evaluationFactor;
	private String name;
	public static final int BD_PRICE = 1; // 投标价
	public static final int MODIFY_PRICE = 11; // 修正金额
	public static final int MODIFY_REASON = 12; // 修自原因
	public static final int BID_PRICE = 2; // 评标价
	public static final int BASE_PRICE = 3; // 基准价
	public static final int PRICE_SCORE = 4;// 价格得分
	public static final int PRICE_FINAL_SCORE = 5; // 最终得分
	public static final int BID_PRICE_TOTAL = 6; // 投标价
	public static final int TOTAL_MODIFY_PRICE = 61; // 修正金额
	public static final int TOTAL_MODIFY_REASON = 62; // 修自原因
	public static final int BID_EVAL_PRICE_TOTAL = 7; // 总报价
	public static final int DEVIATION_RATE = 8; // 偏差率
	
	
	private int factorType = PRICE_SCORE;
	
	public PriceEvaluationFactor(EvaluationFactor evaluationFactor){
		this.evaluationFactor = evaluationFactor;
	}
	public BidPrice getBidPrice() {
		return bidPrice;
	}
	public void setBidPrice(BidPrice bidPrice) {
		this.bidPrice = bidPrice;
	}
	public BidPriceResult getBidPriceResult() {
		return bidPriceResult;
	}
	public void setBidPriceResult(BidPriceResult bidPriceResult) {
		this.bidPriceResult = bidPriceResult;
	}
	public EvaluationFactor getEvaluationFactor() {
		return evaluationFactor;
	}
	public void setEvaluationFactor(EvaluationFactor evaluationFactor) {
		this.evaluationFactor = evaluationFactor;
	}
	
	public String getName() {
//		switch(factorType){
//		case BID_PRICE:
//			return Messages.EvaluationPrice+(null != tenderProjectRuleEntity? ("（"+ tenderProjectRuleEntity.getPriceUintCN()+"）"):"");
//		case BASE_PRICE:
//			return "基准价";
//		case PRICE_SCORE:
//			return "价格得分";
//		}
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public int getFactorType() {
		return factorType;
	}
	public void setFactorType(int factorType) {
		this.factorType = factorType;
	}
	public PriceEvaluationFactor clone(int factorType){
		PriceEvaluationFactor priceEvaluationFactor = new PriceEvaluationFactor(evaluationFactor);
		priceEvaluationFactor.setBidPrice(bidPrice);
		priceEvaluationFactor.setFactorType(factorType);
		priceEvaluationFactor.setBidPriceResult(bidPriceResult);
		return priceEvaluationFactor;
	}
}
