package com.gx.obe.business.vo;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

import com.gx.obe.util.utils.BigDecimalUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.web.entity.evaluation.EvaluationStep;

/**
 * @Description: 
 * @author guoyr
 */
/**
 * @preserve private
 */
public class RatesCheckResult {
	
	private String id;
	private String code;//评审项目编号
	private String name;//评审项目
	private boolean reasonable;// 是否合理
	private String opinion;// 检查结果
	private String errorItem;// 错误项
	private String correctItem;// 正确项
	private BigDecimal price;// 报出金额
	private BigDecimal calculate;// 计算基数
	private String calculateRemark;// 计算基数说明
	private BigDecimal rate;// 报出费率%
	private BigDecimal baseRate;// 规定费率%
	private BigDecimal difference;// 差额
	private BigDecimal differenceRate;
	private RatesCheckResult parent;
	private String parentId;
	private String checkType;
	private EvaluationStep evaluationStep;
	private List<RatesCheckResult> childList = new ArrayList<RatesCheckResult>();
	
	public RatesCheckResult() {}
	
	public RatesCheckResult(EvaluationStep evaluationStep) {
		this.evaluationStep = evaluationStep;
	}
	
	public String getId() {
		return id;
	}
	
	public void setId(String id) {
		this.id = id;
	}
	
	public String getCode() {
		return code;
	}
	
	public void setCode(String code) {
		this.code = code;
	}
	
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	public void setReasonable(boolean reasonable) {
		this.reasonable = reasonable;
	}
	
	public String getOpinion() {
		return opinion;
	}
	
	public void setOpinion(String opinion) {
		this.opinion = opinion;
	}
	
	public String getErrorItem() {
		return errorItem;
	}
	
	public void setErrorItem(String errorItem) {
		this.errorItem = errorItem;
	}
	
	public String getCorrectItem() {
		return correctItem;
	}
	
	public void setCorrectItem(String correctItem) {
		this.correctItem = correctItem;
	}
	
	public RatesCheckResult getParent() {
		return parent;
	}
	
	public void setParent(RatesCheckResult parent) {
		this.parent = parent;
	}
	
	public String getParentId() {
		return parentId;
	}
	
	public void setParentId(String parentId) {
		this.parentId = parentId;
	}
	
	public List<RatesCheckResult> getChildList() {
		return childList;
	}
	
	public void setChildList(List<RatesCheckResult> childList) {
		this.childList = childList;
	}
	
	public BigDecimal getPrice() {
		return price;
	}
	
	public void setPrice(BigDecimal price) {
		this.price = price;
	}
	
	public BigDecimal getCalculate() {
		return calculate;
	}
	
	public void setCalculate(BigDecimal calculate) {
		this.calculate = calculate;
	}
	
	public String getCalculateRemark() {
		return calculateRemark;
	}
	
	public void setCalculateRemark(String calculateRemark) {
		this.calculateRemark = calculateRemark;
	}
	
	public BigDecimal getRate() {
		return rate;
	}
	
	public void setRate(BigDecimal rate) {
		this.rate = rate;
	}
	
	public BigDecimal getBaseRate() {
		return baseRate;
	}
	
	public void setBaseRate(BigDecimal baseRate) {
		this.baseRate = baseRate;
	}
	
	public void addChild(RatesCheckResult child) {
		childList.add(child);
	}
	
	public String getCheckType() {
		return checkType;
	}
	
	public void setCheckType(String checkType) {
		this.checkType = checkType;
	}
	
	public BigDecimal getDifferenceRate() {
		if (null != differenceRate) {
			return differenceRate;
		} else {
//			differenceRate = BigDecimalUtils.mul(BigDecimalUtils.div(getDifference(), getPrice(), 4), BigDecimal.valueOf(100));
			differenceRate = BigDecimalUtils.mul(BigDecimalUtils.div(getDifference(), getPrice()), BigDecimal.valueOf(100));
			if (differenceRate.compareTo(BigDecimal.ZERO) == 0) {
				differenceRate = BigDecimal.ZERO;
			}
		}
		return differenceRate;
	}
	
	public void setDifferenceRate(BigDecimal differenceRate) {
		this.differenceRate = differenceRate;
	}
	
	public BigDecimal getDifference() {
		if (null != difference) {
			return difference;
		} else {
			difference = BigDecimalUtils.sub(getPrice(), getCalculate());
			if (null == difference) {
				difference = BigDecimal.ZERO;
			}
		}
		return difference;
	}
	
	public void setDifference(BigDecimal difference) {
		this.difference = difference;
	}
	
	public boolean isReasonable() {
		String calculationError = EvaluationStep.CALCULATION_ERROR_RATE;
		if (null != evaluationStep) {
			calculationError = evaluationStep.getEvaluationParamByKey(EvaluationStep.CALCULATION_ERROR);
		}
		// 如果是根据差额率来计算
		if (ObjectUtils.equals(calculationError, EvaluationStep.CALCULATION_ERROR_RATE)) {
			BigDecimal rate = BigDecimal.valueOf(5);
			if (null != evaluationStep) {
				rate = evaluationStep.getEvaluationParamByKey(EvaluationStep.CALCULATION_ERROR_RATE, BigDecimal.class);
			}
			if (null == rate || rate.compareTo(BigDecimal.ZERO) == 0) {
				rate = BigDecimal.valueOf(5);
			}
			
			BigDecimal _differenceRate = getDifferenceRate();
			// 如果差额率小于0
			if (getDifferenceRate().compareTo(BigDecimal.ZERO) < 0) {
				_differenceRate = BigDecimalUtils.sub(BigDecimal.ZERO, getDifferenceRate());
			}
			if (_differenceRate.compareTo(rate) > 0) {
				reasonable = false;
			} else {
				reasonable = true;
			}
		} else {
			
			BigDecimal value = BigDecimal.valueOf(20);
			if (null != evaluationStep) {
				value = evaluationStep.getEvaluationParamByKey(EvaluationStep.CALCULATION_ERROR_VALUE, BigDecimal.class);
			}
			if (null == value || value.compareTo(BigDecimal.ZERO) == 0) {
				value = BigDecimal.valueOf(20);
			}
			BigDecimal _difference = getDifference();
			// 如果差额小于0
			if (getDifference().compareTo(BigDecimal.ZERO) < 0) {
				_difference = BigDecimalUtils.sub(BigDecimal.ZERO, getDifference());
			}
			if (_difference.compareTo(value) > 0) {
				reasonable = false;
			} else {
				reasonable = true;
			}
		}
		return reasonable;
	}
}
