package com.gx.obe.business.vo;

import java.util.HashMap;
import java.util.Map;

/**
 * @Description: 分部分项
 * @author chenxw
 */
/**
 * @preserve private
 */
public class TotalParameter {
	
	private String id;
	
	private String projectId;
	
	private SubTotalParameter subTotalParameter;
	
	private Map<String, QdParameter> qdParameterMap = new HashMap<String, QdParameter>();//清单列表
	
	public String getId() {
		return id;
	}
	
	public void setId(String id) {
		this.id = id;
	}
	
	/**
	 * @Description: 获取清单列表
	 * @author chenxw
	 * @return
	 */
	public Map<String, QdParameter> getQdParameterMap() {
		return qdParameterMap;
	}
	
	/**
	 * @Description: 添加清单
	 * @author chenxw
	 * @param qdParameter
	 */
	public void addQdParameter(QdParameter qdParameter) {
		qdParameter.setSubTotalParameter(subTotalParameter);
		qdParameterMap.put(qdParameter.getId(), qdParameter);
	}
	
	/**
	 * @Description: 获取清单
	 * @author chenxw
	 * @param key
	 * @return
	 */
	public QdParameter get(String key) {
		return qdParameterMap.get(key);
	}
	
	/**
	 * @Description: 是否含有此清单
	 * @author chenxw
	 * @param key
	 * @return
	 */
	public boolean containsKey(String key) {
		return qdParameterMap.containsKey(key);
	}
	
	public void setProjectId(String projectId) {
		this.projectId = projectId;
	}
	
	public String getProjectId() {
		return projectId;
	}
	
	public void setSubFbfxParameter(SubTotalParameter subTotalParameter) {
		this.subTotalParameter = subTotalParameter;
	}
	
}
