package com.gx.obe.web.file.service;

import java.util.HashMap;
import java.util.Map;

import org.apache.log4j.Logger;

import com.gx.obe.business.entity.Result;
import com.gx.obe.components.core.Constants;
import com.gx.obe.http.json.JsonUtil;
import com.gx.obe.web.utils.NetworkRequest;
import com.gx.obe.web.utils.ResultStatus;

public class DownloadFileService {
	private Logger logger = Logger.getLogger(DownloadFileService.class);

	static final String URL = "download";
	
	/**
	 * @Description: 
	 * @author mazc
	 * @param fileURL 文件下载路径
	 * @return 
	 */
	@SuppressWarnings("unchecked")
	public Result<String> getFileMD5Value(String fileURL){
		//请求地址
		String strWebServerUrl = Constants.getServiceUrl( URL + "/getFileMD5");
		Map<String, Object> param = new HashMap<String, Object>();
		param.put("fileURL", fileURL);
  		try {
 			String result = NetworkRequest.post(strWebServerUrl, param);
 			if(ResultStatus.getReultStatusIsNotEmpty(result)){
 				return JsonUtil.jsonToBean(result, Result.class);
 			}
 			return null;
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return null;
		}	
	}
}
