package com.gx.obe.web.platform.service;

import java.util.HashMap;
import java.util.Map;

import org.apache.log4j.Logger;

import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import com.gx.obe.WebserviceConstants;
import com.gx.obe.components.core.Constants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.enttiytdo.LoginUserDTO;
import com.gx.obe.enttiytdo.PlatformResult;
import com.gx.obe.http.HttpResponse;
import com.gx.obe.http.HttpStatus;
import com.gx.obe.http.json.JsonUtil;
import com.gx.obe.util.utils.StringUtil;
import com.gx.obe.web.utils.NetworkRequest;

public class PlatformUserService {
	private static Logger logger = Logger.getLogger(PlatformUserService.class);

	
	
	/**
	 * @Description: 用户名登录
	 * @author mazc 
	 */
	public PlatformResult<LoginUserDTO> userNameLogin(String userName,String password) {
		String method = PropertiesUtils.getWebserviceProperty(WebserviceConstants.SERVER_USER_LOGIN_METHOD, "userHS.do?login");
		String stPlatformUrl = Constants.getPlatformUrl(method);
		Map<String, Object> param = new HashMap<String, Object>();
		param.put("userName", userName);
		param.put("password", StringUtil.encodeString(password));
 		try {
 			HttpResponse httpResponse = NetworkRequest.postHttpResponse(stPlatformUrl, param);
 			if(HttpStatus.HTTP_OK == httpResponse.getStatus()) {
 				@SuppressWarnings("unchecked")
 				PlatformResult<LoginUserDTO> resultData = JsonUtil.jsonToBean(httpResponse.body(), PlatformResult.class);
 				if(null == resultData) {
 					return null;
 				}
 				resultData.setData(JsonUtil.jsonToBean(resultData.getData(), LoginUserDTO.class));
 				return resultData;
 			}
 			return null;
 		} catch (Exception e) {
 			logger.error(e.getMessage(), e);
 			return null;
 		}
	}


	/**
	 * 二次验证
	 * @param checkUserLogin
	 */
	public String verify(String checkUserLogin) {
		// TODO Auto-generated method stub
		String method = PropertiesUtils.getWebserviceProperty(WebserviceConstants.TWO_VIRIF, "userHS.do?checkEncryptionInfo");
		String stPlatformUrl = Constants.getPlatformUrl(method);
		Map<String, Object> param = new HashMap<String, Object>();
		param.put("checkUserLogin", checkUserLogin);
		HttpResponse httpResponse = NetworkRequest.postHttpResponse(stPlatformUrl, param);
			if(HttpStatus.HTTP_OK == httpResponse.getStatus()) {
				String bodyJson = httpResponse.body();
				JsonParser jsonParser=new JsonParser();
				JsonObject bodyObject = jsonParser.parse(bodyJson).getAsJsonObject();
				JsonObject dataObject = bodyObject.getAsJsonObject("data");
				String data  = dataObject.get("data").getAsString();
				return data;
			}
			return null;
	}
}
