package com.gx.obe.web.service;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.log4j.Logger;

import com.gx.obe.business.vo.SaveSupplierBidPriceResultVo;
import com.gx.obe.components.core.Constants;
import com.gx.obe.http.json.JsonUtil;
import com.gx.obe.http.util.WebReflecUtill;
import com.gx.obe.web.entity.SupplierOpeningResult;
import com.gx.obe.web.entity.Result.RequestBody;
import com.gx.obe.web.entity.price.BidPrice;
import com.gx.obe.web.entity.price.BidPriceResult;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import  com.gx.obe.web.utils.NetworkRequest;
import com.gx.obe.web.utils.ResultStatus;
import com.gx.obe.web.vo.SaveSubBidPriceResultVo;
import com.gx.obe.web.vo.SaveSupplierInputBidPriceResultVo;
import com.gx.obe.web.vo.SaveSupplierInputEvaluationPriceResultVo;
import com.gx.obe.web.vo.UpdateAssignPropertyVo;

/** 
 * @Description: 鎶曟爣鎶ヤ环鏁版嵁鎺ュ彛
 * @author mazc 
 */
public class BidPriceResultService {
	
	static final String URL = "bidPriceResult";
	
	private Logger logger = Logger.getLogger(BidPriceResultService.class);
	

	
	/**
	 * @Description: 鑾峰緱渚涘簲鍟嗙殑鍒嗛」鎶ヤ环缁撴灉
	 * @author mazc
	 * @param tenderId
	 * @param bidPriceId
	 * @return 
	 */
	public List<BidPriceResult> getBidPriceResultList(String tenderId, String bidPriceId){
		//璇锋眰鍦板潃
		String strWebServerUrl = Constants.getServiceUrl( URL + "/findBidPriceResultList");
 		Map<String, Object> param = new HashMap<String, Object>();
		param.put("tenderId", tenderId);
//		if(null != bidPriceId ){
			param.put("bidPriceId", bidPriceId);
//		}
		try {
			String result = NetworkRequest.get(strWebServerUrl, param);
			if(ResultStatus.getReultStatusOK(result)){
				return JsonUtil.jsonToList(result, BidPriceResult.class);				
			}
			return null;
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return null;
		}
	}

	/**
	 * @Description: 鑾峰緱渚涘簲鍟嗗紑鏍囦竴瑙堣〃
	 * @author guoyr
	 * @param tenderId
	 * @param supplierId
	 * @return 
	 */
	public List<BidPriceResult> getBidPriceResultTableList(String tenderId, String supplierId){
		String strWebServerUrl = Constants.getServiceUrl( URL + "/getBidPriceResultTableList");
		Map<String, Object> param = new HashMap<String, Object>();
		param.put("tenderId", tenderId);
		param.put("supplierId", supplierId);
		try {
			String result = NetworkRequest.get(strWebServerUrl, param);
			if(ResultStatus.getReultStatusOK(result)){
				return JsonUtil.jsonToList(result, BidPriceResult.class);				
			}
			return null;
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return null;
		}
	}
	
	/**
	 * @Description:  鑾峰緱鍒嗛」鎶ヤ环缁撴灉
	 * @author mazc
	 * @param tenderId
	 * @return 
	 */
	public List<BidPriceResult> getBidPriceResultList(String tenderId){
		//璇锋眰鍦板潃
		String strWebServerUrl = Constants.getServiceUrl( URL + "/getBidPriceResultList");
 		Map<String, Object> param = new HashMap<String, Object>();
		param.put("tenderId", tenderId);
		try {
			String result = NetworkRequest.get(strWebServerUrl, param);
			if(ResultStatus.getReultStatusOK(result)){
				return JsonUtil.jsonToList(result, BidPriceResult.class);				
			}
			return null;
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return null;
		}
	}


	/**
	 * @Description: 鑾峰緱鍞辨爣鐨勫垎椤规姤浠�
	 * @author mazc
	 * @param tenderId
	 * @return 
	 */
	@Deprecated
	public List<BidPriceResult> getSingBidPriceResultList(String tenderId){
		//璇锋眰鍦板潃
		String strWebServerUrl = Constants.getServiceUrl( URL + "/getSingBidPriceResultList");
 		Map<String, Object> param = new HashMap<String, Object>();
		param.put("tenderId", tenderId);
		try {
			String result = NetworkRequest.get(strWebServerUrl, param);
			if(ResultStatus.getReultStatusOK(result)){
				return JsonUtil.jsonToList(result, BidPriceResult.class);				
			}
			return null;
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return null;
		}
	}
	
	
	/**
	 * @Description: 鑾峰緱渚涘簲鍟嗙殑鍒嗛」鎶ヤ环
	 * @author mazc
	 * @param tenderId
	 * @param supplierId
	 * @return 
	 */
	public List<BidPriceResult> getSupplierBidPriceResultList(String tenderId, String supplierId){
		//璇锋眰鍦板潃
		String strWebServerUrl = Constants.getServiceUrl( URL + "/getSupplierBidPriceResultList");
 		Map<String, Object> param = new HashMap<String, Object>();
		param.put("tenderId", tenderId);
		param.put("supplierId", supplierId);
		try {
			String result = NetworkRequest.get(strWebServerUrl, param);
			if(ResultStatus.getReultStatusOK(result)){
				return JsonUtil.jsonToList(result, BidPriceResult.class);				
			}
			return null;
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return null;
		}
	}
	
	/**
	 * @Description: 鑾峰緱渚涘簲鍟嗙殑鍒嗛」鎶ヤ环
	 * @author mazc
	 * @param bidPriceId
	 * @param supplierId
	 * @return 
	 */
	public BidPriceResult getSupplierBidPriceResult(String bidPriceId, String supplierId){
		//璇锋眰鍦板潃
		String strWebServerUrl = Constants.getServiceUrl( URL + "/getSupplierBidPriceResult");
 		Map<String, Object> param = new HashMap<String, Object>();
		param.put("bidPriceId", bidPriceId);
		param.put("supplierId", supplierId);
		try {
			String result = NetworkRequest.get(strWebServerUrl, param);
			if(ResultStatus.getReultStatusOK(result)){
				return JsonUtil.jsonToBean(result, BidPriceResult.class);				
			}
			return null;
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return null;
		}
	}
	
	/**
	 * @Description: 淇濆瓨鍒嗛」鎶ヤ环鍜屾�绘姤浠�
	 * @author mazc
	 * @param tenderId
	 * @param supplierOpeningResultList
	 * @param bidPriceResultList
	 * @return 
	 */
	public boolean saveSubBidPriceResult(String tenderId, List<SupplierOpeningResult> supplierOpeningResultList, List<BidPriceResult> bidPriceResultList, boolean isEvaluationPrice){
		String strWebServerUrl = Constants.getServiceUrl( URL + "/saveSubBidPriceResult");
		SaveSubBidPriceResultVo  saveSubBidPriceResultVo = new SaveSubBidPriceResultVo();
		saveSubBidPriceResultVo.setTenderId(tenderId);
		saveSubBidPriceResultVo.setEvaluationPrice(isEvaluationPrice);
		saveSubBidPriceResultVo.setBidPriceResultList(bidPriceResultList);
		saveSubBidPriceResultVo.setSupplierOpeningResultList(supplierOpeningResultList);
		try {
			String result = NetworkRequest.post(strWebServerUrl, JsonUtil.jsonObjectToStr(saveSubBidPriceResultVo));
			return ResultStatus.getReultStatusBoolean(result);
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return false;
		}
	}
	
	/**
	 * @Description: 淇濆瓨渚涘簲鍟嗙殑鎶ヤ环淇℃伅
	 * @author mazc
	 * @param tenderId
	 * @param supplierOpeningResult
	 * @param newBidPriceList 鏂板鐨勫垎椤规姤浠�
	 * @param newBidPriceItemList 鏂板鐨勫垎椤规姤浠锋槑缁�
	 * @param bidPriceResultList 鍒嗛」鎶ヤ环鍒楄〃
	 * @param bidPriceItemResultList 鍒嗛」鎶ヤ环鏄庣粏鍒楄〃
	 */
	public SupplierOpeningResult saveSupplierBidPriceResult(String tenderId, SupplierOpeningResult supplierOpeningResult, String businessBidStatus, String technologyBidStatus, String priceBidStatus, String bidOpeningStatus, Date bidOpeningTime, String bidOpeningRecord, List<BidPrice> newBidPriceList, List<BidPriceResult> bidPriceResultList){
		String strWebServerUrl = Constants.getServiceUrl( URL + "/saveSupplierBidPriceResult");
		SaveSupplierBidPriceResultVo saveSupplierBidPriceResultVo = new SaveSupplierBidPriceResultVo();
		saveSupplierBidPriceResultVo.setBidOpeningRecord(bidOpeningRecord);
		saveSupplierBidPriceResultVo.setBidOpeningStatus(bidOpeningStatus);
		saveSupplierBidPriceResultVo.setBidOpeningTime(bidOpeningTime);
		saveSupplierBidPriceResultVo.setBidPriceResultList(bidPriceResultList);
		saveSupplierBidPriceResultVo.setBusinessBidStatus(businessBidStatus);
		saveSupplierBidPriceResultVo.setNewBidPriceList(newBidPriceList);
		saveSupplierBidPriceResultVo.setPriceBidStatus(priceBidStatus);
		saveSupplierBidPriceResultVo.setSupplierOpeningResult(supplierOpeningResult);
		saveSupplierBidPriceResultVo.setTechnologyBidStatus(technologyBidStatus);
		saveSupplierBidPriceResultVo.setTenderId(tenderId);
		try {
			String result = NetworkRequest.post(strWebServerUrl, JsonUtil.jsonObjectToStr(saveSupplierBidPriceResultVo));
			if(ResultStatus.getReultStatusOK(result)){
				return JsonUtil.jsonToBean(result, SupplierOpeningResult.class);				
			}
			return null;
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return null;
		}
	}
	
	/** 
	 * @Description: 琛ュ綍寮�鏍囩粨鏋�
	 * @author mazc
	 * @param supplierOpeningResult
	 * @param bidPriceResultList
	 * @param bidPriceItemResultList
	 * @return 
	 */
	public boolean saveSupplierInputBidPriceResult(TenderProjectEntity tenderProjectEntity, SupplierOpeningResult supplierOpeningResult, List<BidPriceResult> bidPriceResultList, boolean allBidStatus){
		String strWebServerUrl = Constants.getServiceUrl( URL + "/saveSupplierInputBidPriceResult");
		SaveSupplierInputBidPriceResultVo saveSupplierInputBidPriceResultVo = new SaveSupplierInputBidPriceResultVo();
		saveSupplierInputBidPriceResultVo.setAllBidStatus(allBidStatus);
		saveSupplierInputBidPriceResultVo.setBidPriceResultList(bidPriceResultList);
		saveSupplierInputBidPriceResultVo.setSupplierOpeningResult(supplierOpeningResult);
		saveSupplierInputBidPriceResultVo.setTenderId(tenderProjectEntity.getId());
		saveSupplierInputBidPriceResultVo.setProjectId(tenderProjectEntity.getParentId());
		try {
			String result = NetworkRequest.post(strWebServerUrl, JsonUtil.jsonObjectToStr(saveSupplierInputBidPriceResultVo));
			return ResultStatus.getReultStatusBoolean(result);
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return false;
		}
	}
	
//	/**
//	 * @Description: 淇濆瓨渚涘簲鍟嗗杞姤浠�
//	 * @author guoyr
//	 * @param tenderId
//	 * @param supplierId
//	 * @param bidPriceResultList
//	 * @return 
//	 */
//	public boolean saveSupplierReBidPriceResult(String tenderId, String supplierId, List<BidPriceResult> bidPriceResultList ,String roundId){
//
//		String strWebServerUrl = Constants.getServiceUrl( URL + "/saveSupplierReBidPriceResult");
//		RequestBody<BidPriceResult> requestBody = new RequestBody<BidPriceResult>(); 
//		requestBody.setEntityList(bidPriceResultList);
//		requestBody.setParam("tenderId", tenderId);
//		requestBody.setParam("supplierId", supplierId);
//		if(StringUtils.isNotEmpty(roundId)) {
//			requestBody.setParam("roundId", roundId);
//		}
//		try {
//			String result = NetworkRequest.post(strWebServerUrl, JsonUtil.jsonObjectToStr(requestBody));
//			return ResultStatus.getReultStatusBoolean(result);
//		} catch (Exception e) {
//			logger.error(e.getMessage(), e);
//			return false;
//		}
//	
//	}
	
	/** 
	 * @Description: 琛ュ綍璇勬爣浠�
	 * @author mazc
	 * @param supplierOpeningResult
	 * @param bidPriceResultList
	 * @return 
	 */
	@Deprecated 
	public boolean saveSupplierInputEvaluationPriceResult(SupplierOpeningResult supplierOpeningResult, List<BidPriceResult> bidPriceResultList){
		String strWebServerUrl = Constants.getServiceUrl( URL + "/saveSupplierInputEvaluationPriceResult");
		SaveSupplierInputEvaluationPriceResultVo saveSupplierInputEvaluationPriceResultVo = new SaveSupplierInputEvaluationPriceResultVo();
		saveSupplierInputEvaluationPriceResultVo.setBidPriceResultList(bidPriceResultList);
		saveSupplierInputEvaluationPriceResultVo.setSupplierOpeningResult(supplierOpeningResult);
		try {
			String result = NetworkRequest.post(strWebServerUrl, JsonUtil.jsonObjectToStr(saveSupplierInputEvaluationPriceResultVo));
			return ResultStatus.getReultStatusBoolean(result);
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return false;
		}
	}
	
	/**
	 * @Description: 淇濆瓨姹囩巼杞崲鍚庣殑璇勬爣浠�
	 * @author mazc
	 * @param tenderProjectEntity
	 * @param bidPriceResultList
	 * @return 
	 */
	public boolean saveExchangeRateEvaluation(TenderProjectEntity tenderProjectEntity, List<BidPriceResult> bidPriceResultList){
		RequestBody<BidPriceResult> requestBody = new RequestBody<BidPriceResult>();
		requestBody.setEntityList(bidPriceResultList);
		requestBody.setParam("tenderProjectEntity", tenderProjectEntity);
		String strWebServerUrl = Constants.getServiceUrl( URL + "/saveExchangeRateEvaluation");
		try {
			String result = NetworkRequest.post(strWebServerUrl, JsonUtil.jsonObjectToStr(requestBody));
			return ResultStatus.getReultStatusBoolean(result);
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return false;
		}
	}
	
	public boolean insert(BidPriceResult bidPriceResult){
		String strWebServerUrl = Constants.getServiceUrl( URL + "/insert");
		try {
			String result = NetworkRequest.post(strWebServerUrl, JsonUtil.jsonObjectToStr(bidPriceResult));
			return ResultStatus.getReultStatusBoolean(result);
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return false;
		}
	} 
	
	public boolean hasBidPriceResult(String tenderId){
		String strWebServerUrl = Constants.getServiceUrl( URL + "/hasBidPriceResult");
		Map<String, Object> param = new HashMap<String, Object>();
		param.put("tenderId", tenderId);
		try {
			String result = NetworkRequest.get(strWebServerUrl, param);
			return ResultStatus.getReultStatusBoolean(result);
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return false;
		}
	}
	
	/**
	 * @Description: 
	 * @author mazc
	 * @param tenderId
	 * @param bidPrice
	 * @return 
	 */
	public List<BidPriceResult> getTenderIdAndBidPrice(String tenderId, String bidPrice){
		//璇锋眰鍦板潃
		String strWebServerUrl = Constants.getServiceUrl( URL + "/getTenderIdAndBidPrice");
 		Map<String, Object> param = new HashMap<String, Object>();
		param.put("tenderId", tenderId);
		param.put("bidPrice", bidPrice);
		try {
			String result = NetworkRequest.get(strWebServerUrl, param);
			if(ResultStatus.getReultStatusOK(result)){
				return JsonUtil.jsonToList(result, BidPriceResult.class);				
			}
			return null;
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return null;
		}
	}
	
	/**
	 * @Description: 鎸囧畾瀛楁淇敼
	 * @author chenxw
	 * @param bidPriceResult
	 * @param attributes
	 * @return 
	 */
	public boolean updateAssignProperty(BidPriceResult bidPriceResult, String[] attributes) {
		//鐧婚檰璇锋眰鍦板潃
		String strWebServerUrl = Constants.getServiceUrl(URL + "/updateAssignProperty");
		UpdateAssignPropertyVo<BidPriceResult> updateAssignPropertyVo = new UpdateAssignPropertyVo<BidPriceResult>();
		updateAssignPropertyVo.setEntity(bidPriceResult);
		updateAssignPropertyVo.setAttributes(attributes);
		try {
			String result = NetworkRequest.post(strWebServerUrl, JsonUtil.jsonObjectToStr(updateAssignPropertyVo));
			return ResultStatus.getReultStatusBoolean(result);
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return false;
		}
	}
	
	/**
	 * @Description: 淇濆瓨鎴栨洿鏂�
	 * @author mazc
	 * @param supplierList
	 * @param attributes 瑕佽窡鏂扮殑瀛楁
	 */
	public Integer batchSaveOrUpdate(List<BidPriceResult> list,String [] attributes){
		List<BidPriceResult>  newList;
		if(null != attributes && attributes.length > 0){
			newList  = new ArrayList<BidPriceResult>();
			for(BidPriceResult evaluationFactor : list){
				WebReflecUtill<BidPriceResult> utill = new WebReflecUtill<BidPriceResult>();
				BidPriceResult ruleEntity =  (BidPriceResult) utill.reflex(evaluationFactor, attributes,BidPriceResult.class);
				if(null != ruleEntity){
					newList.add(ruleEntity);
				}
			}
 		}else{
 			newList = list;
		}
		//璇锋眰鍦板潃
		String strWebServerUrl = Constants.getServiceUrl(URL + "/batchSaveOrUpdate");
		try{
			String result = NetworkRequest.post(strWebServerUrl, JsonUtil.jsonObjectToStr(newList));
			if(ResultStatus.isReultStatusInteger(result)){	
				return Integer.valueOf(result);
			}
			return 0;
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return 0;
		}
	}
	public boolean updateCurrencyCodeAndPriceUnitAndEvaluationPrice(String tenderId,String bidPriceId,String supplierId,String priceUnit,String currencyCode,String bidPrice, String evaluationPrice,String evaluationPriceOriginal){
		String strWebServerUrl = Constants.getServiceUrl(URL + "/updateCurrencyCodeAndPriceUnitAndEvaluationPrice");
		Map<String, Object> param = new HashMap<String, Object>();
		param.put("tenderId", tenderId);
		param.put("bidPriceId", bidPriceId);
		param.put("supplierId", supplierId);
		param.put("priceUnit", priceUnit);
		param.put("currencyCode", currencyCode);
		param.put("bidPrice", bidPrice);
		param.put("evaluationPrice", evaluationPrice);
		param.put("evaluationPriceOriginal", evaluationPriceOriginal);
		try{
			String result = NetworkRequest.get(strWebServerUrl, param);
			return ResultStatus.getReultStatusBoolean(result);
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return false;
		}
	}

	/**
	 * @Description: 鏇存柊鎶曟爣鎶ヤ环
	 * @author chenxw
	 * @param bidPriceResult
	 * @return 
	 */
	public boolean updateBidPriceResultOrSum(BidPriceResult bidPriceResult) {
		String strWebServerUrl = Constants.getServiceUrl(URL + "/updateBidPriceResultOrSum");
		try {
			String result = NetworkRequest.post(strWebServerUrl, JsonUtil.jsonObjectToStr(bidPriceResult));
			return ResultStatus.getReultStatusBoolean(result);
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return false;
		}
	}
	
	/**
	 * @Description: 灏嗘湭瀹屾垚鎶ヤ环鐨勪緵搴斿晢鎶ヤ环鑷姩濉厖涓婁竴杞姤浠�
	 * @author mazc
	 * @param tenderId
	 * @return 
	 */
	public boolean updateSupplierIdNotRecordedBidPrice(String tenderId,String roundId){
		String strWebServerUrl = Constants.getServiceUrl(URL + "/updateSupplierIdNotRecordedBidPrice");
		try {
			Map<String, Object> param = new HashMap<String, Object>();
			param.put("tenderId", tenderId);
			param.put("roundId", roundId);
 			String result = NetworkRequest.post(strWebServerUrl, param);
			return ResultStatus.getReultStatusBoolean(result);
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return false;
		}
	}
}
