package com.gx.obe.web.utils;

import java.math.BigDecimal;

import com.gx.obe.http.util.StrUtil;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.StatusEntity;

public class ResultStatus {
	
	public static final String OK = "ok";
	
	public static final String ERROR = "error";
	
	/**
	 * @Description: 是否有返回数据
	 * @author mazc
	 * @param result
	 * @return 
	 */
	public static boolean getReultStatusOK(String result){
		if(StringUtils.isNotEmpty(result)){
			return true;
		}
		return false;	
	}
	
	public boolean getHttpStatus(String result){
		return StrUtil.containsAnyIgnoreCase(result, "","","");
	}
	
	public static boolean isReultStatusInteger(String result){
		return getReultStatusIsNotEmpty(result) && StrUtil.isInteger(result);
	}
	
    public static BigDecimal getReultStatusBigDecimal(String result) {
        if (getReultStatusIsNotEmpty(result)) {
            try {
                return new BigDecimal(result);
            } catch (NumberFormatException e) {}
        }
        return null;
    }
	
	public static boolean getReultStatusBoolean(String result){
		return getReultStatusIsNotEmpty(result) && StatusEntity.TRUE.equals(result);
		
	}
	
	public static boolean getReultStatusIsNotEmpty(String result){
		return StringUtils.isNotEmpty(result);
	}
	
}
